<template>
    <div class="dashboard">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.ACCOUNT') }}
                        </h1>
                    </v-col>
                </v-row>

                <v-row
                    :class="[
                        { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16 pb-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col cols="12">
                        <!-- EDIT PROFILE -->
                        <v-row>
                            <v-col cols="6"
                                ><p
                                    v-if="user"
                                    class="font-14 font-metropolis-regular text-white mb-1"
                                >
                                    {{ user.firstName }} {{ user.lastName }}
                                </p>
                                <p
                                    v-if="user"
                                    class="font-14 font-metropolis-regular text-grey mb-1"
                                >
                                    {{ user.email }}
                                </p>
                                <p
                                    v-if="user"
                                    class="font-14 font-metropolis-regular text-grey"
                                >
                                    {{ user.mobile ? user.mobile : '' }}
                                </p>
                                <v-skeleton-loader
                                    v-else
                                    id="dataLoader"
                                    :loading="true"
                                    class="mx-auto"
                                    max-width="auto"
                                    type="setences"
                            /></v-col>
                            <v-col cols="6" class="text-right"
                                ><v-btn
                                    x-small
                                    text
                                    color="red"
                                    class="lowercase"
                                    @click="goToPage(menus.PROFILE.id)"
                                    >{{ $t('dashboard.editProfile') }}</v-btn
                                ></v-col
                            >
                        </v-row>
                        <v-divider />

                        <!-- EDIT ADDRESS -->
                        <v-row class="mt-5">
                            <v-col cols="6"
                                ><p
                                    class="font-14 font-metropolis-regular text-white mb-1"
                                >
                                    {{ $t('dashboard.menu.ADDRESS') }}
                                </p>
                                <p
                                    v-if="
                                        shippingAddress.length > 0 ||
                                        shippingAddress
                                    "
                                    class="font-metropolis-regular text-grey mb-0"
                                >
                                    {{ shippingAddress.firstName }}
                                    {{ shippingAddress.lastName }}
                                </p>
                                <p
                                    v-if="
                                        shippingAddress.length > 0 ||
                                        shippingAddress
                                    "
                                    class="font-metropolis-regular font-12 text-grey mb-0"
                                >
                                    {{ shippingAddress.address1 }}
                                </p>
                                <p
                                    v-if="
                                        shippingAddress.length > 0 ||
                                        shippingAddress
                                    "
                                    class="font-metropolis-regular font-12 text-grey mb-0"
                                >
                                    {{
                                        shippingAddress.address2
                                            ? shippingAddress.address2 +
                                              ', ' +
                                              shippingAddress.city
                                            : shippingAddress.city
                                    }}
                                </p>
                                <p
                                    v-if="
                                        shippingAddress.length > 0 ||
                                        shippingAddress
                                    "
                                    class="font-metropolis-regular font-12 text-grey mb-0"
                                >
                                    {{
                                        shippingAddress.postcode
                                            ? shippingAddress.postcode +
                                              ',' +
                                              shippingAddress.state
                                            : shippingAddress.state
                                    }}
                                </p>
                                <p
                                    v-if="
                                        shippingAddress.length > 0 ||
                                        shippingAddress
                                    "
                                    class="font-metropolis-regular font-12 text-grey mb-0"
                                >
                                    {{ shippingAddress.country }}
                                </p>
                                <v-skeleton-loader
                                    v-else
                                    id="dataLoader"
                                    :loading="true"
                                    class="mx-auto"
                                    max-width="auto"
                                    type="paragraph"
                                />
                            </v-col>
                            <v-col cols="6" class="text-right"
                                ><v-btn
                                    x-small
                                    text
                                    color="red"
                                    class="lowercase"
                                    @click="goToPage(menus.ADDRESS.id)"
                                    >{{ $t('dashboard.editAddress') }}</v-btn
                                ></v-col
                            >
                        </v-row>
                        <v-divider />
                        <!-- EDIT ORDERS -->
                        <v-row class="mt-5">
                            <v-col cols="6"
                                ><p
                                    class="font-14 font-metropolis-regular text-white mb-1"
                                >
                                    {{ $t('dashboard.menu.ORDERS') }}
                                </p>
                                <p
                                    class="font-14 font-metropolis-regular text-grey mb-1"
                                >
                                    <!-- {{ user.orders }} -->
                                </p></v-col
                            >
                            <v-col cols="6" class="text-right"
                                ><v-btn
                                    x-small
                                    text
                                    color="red"
                                    class="lowercase"
                                    @click="goToPage(menus.ORDERS.id)"
                                    >{{ $t('dashboard.editOrders') }}</v-btn
                                ></v-col
                            >
                        </v-row>
                        <v-divider />
                        <!-- EDIT SUBSCRIPTION -->
                        <v-row class="mt-5">
                            <v-col cols="6"
                                ><p
                                    class="font-14 font-metropolis-regular text-white mb-1"
                                >
                                    {{ $t('dashboard.menu.SUBSCRIPTION') }}
                                </p>
                                <p
                                    v-if="
                                        planDetails ||
                                        Object.keys(planDetails).length > 0
                                    "
                                    class="font-14 font-metropolis-regular text-grey mb-1"
                                >
                                    {{
                                        Object.keys(planDetails).length > 0
                                            ? planDetails.name +
                                              ' ' +
                                              currencyName +
                                              ' ' +
                                              planDetails.amount +
                                              '/' +
                                              planDetails.interval
                                            : ''
                                    }}
                                </p>
                                <v-skeleton-loader
                                    v-if="
                                        !planDetails &&
                                        Object.keys(planDetails).length !== 0
                                    "
                                    id="dataLoader"
                                    :loading="true"
                                    class="mx-auto"
                                    max-width="auto"
                                    type="text"
                            /></v-col>
                            <v-col cols="6" class="text-right"
                                ><v-btn
                                    x-small
                                    text
                                    color="red"
                                    class="lowercase"
                                    @click="goToPage(menus.SUBSCRIPTION.id)"
                                    >{{
                                        planDetails
                                            ? $t('dashboard.editSubscription')
                                            : $t('dashboard.subscribePlan')
                                    }}</v-btn
                                ></v-col
                            >
                        </v-row>
                        <v-divider />
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            title: this.$t('dashboard.menu.HOME'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        user: 'user/getUser',
        shippingAddress: 'user/getShippingAddress',
        planDetails: 'subscription/getPlanDetails',
        currencyName: 'currency/getCurrencyName',
    }),
})
export default class Dashboard extends Vue {
    // Data
    selectedPage: Number = 0 // dashboard
    menus!: any

    // Methods
    goToPage(id: Number) {
        switch (id) {
            case this.menus.PROFILE.id:
                this.$router.push(this.menus.PROFILE.path)
                break

            case this.menus.ADDRESS.id:
                this.$router.push(this.menus.ADDRESS.path)
                break

            case this.menus.ORDERS.id:
                this.$router.push(this.menus.ORDERS.path)
                break

            case this.menus.SUBSCRIPTION.id:
                this.$router.push(this.menus.SUBSCRIPTION.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    mounted() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
    }
}
</script>
